struct depth{   //In bit
       uint8 red;
       uint8 green;
       uint8 blue;
       uint8 alpha;
       uint8 intensity;
       depth(uint8 r, uint8 g, uint8 b, uint8 a, uint8 i); 
       }__attribute__((__packed__ ));

struct color{
       uint8 red;
       uint8 green;
       uint8 blue;
       uint8 alpha;       
       color(char* color);
       color(uint8 r, uint8 g, uint8 b);
       color(uint8 r, uint8 g, uint8 b, uint8 a);       
       }__attribute__((__packed__ ));

struct vgaColor{
       uint8 tb:1;
       uint8 tg:1;
       uint8 tr:1;
       uint8 ti:1;
       
       uint8 bb:1;
       uint8 bg:1;
       uint8 br:1;
       uint8 bi:1;
       
       
       }__attribute__((__packed__ ));
       
union vgaColor_union{
      vgaColor complex;
      char ch;
      };

class console{
      public:
             console();
             ~console();
             int parse(char* command);
             
             void (*cls)();
             void (*putc)(char);
             void (*puti)(int32, int32);
             void (*puts)(char*);
             void (*print)(char*,uint16,uint16,color,color);
             void (*printi)(int32, int32,uint16,uint16,color,color);
                          
             void (*inputc)();
             void (*inputs)();
             void (*inputn)();
             
             void (*lock)();
             void (*unlock)(char*);
             
             void (*altert)(char*);
             void (*error)(char*);
             void (*warning)(char*);
             uint8 (*confirm)(char*);
             
             void (*drawPointer)();
             void (*pointerXY)();
             
             
             void (*onLeftDown)();
             void (*onMiddleDown)();
             void (*onRightDown)();
             
             void (*onLeftUp)();
             void (*onMiddleUp)();
             void (*onRightUp)();
             
             void (*onLeftDrag)();                     //Starting point
             void (*onMiddleDrag)();
             void (*onRightDrag)();
             
             
             void (*onLeftClick)();
             void (*onMiddleClick)();
             void (*onRightClick)();

             void (*onLeftDragDrop)();
             void (*onMiddleDragDrop)();
             void (*onRightDragDrop)();
             
             void (*onMouseMove)();
             
             
             int16 pointerX;
             int16 pointerY;
      private:
              char cmdPatterns[80][80];
              char cmdBuffer[80];
              
              
              //Code for vars to define...
      };





class frame{
      private:
              static uint32 nextId;
              uint32 id;
              
              frame* parent;
              frame* children[128];

              uint8 status;               //Visible enabled etc etc
              uint8 refreshed;
              
              uint16 width, height, top, left;
              uint32 zindex;
               
      public:
             frame(frame* a_p, uint16 a_w, uint16 a_h, uint16 a_t, uint16 a_l, uint32 a_z);
             frame();
             void refresh();
             void* draw(frame*);      //TO draw
      
      };

extern console System;

