void timer_handler(struct regs *r);
void timer_install();
void timer_wait(int ticks);
void spk_play(uint32 nFrequence);
void spk_nosound();
void spk_beep();

void vga_putc(char c);
void vga_puts(char *c);
void vga_cls();
void vgaRoutinesFor(console* c);
vgaColor fromColor(color t, color b);
void vga_putc(char c, vgaColor p);
void vga_puti(int32 n, int32 b);
void vga_printi(int32 n, int32 base, uint16 x, uint16 y, color t, color b);
void vga_drawPointer();

void mouse_handler(struct regs *r);
inline void mouse_wait(unsigned char a_type);
inline void mouse_write(unsigned char a_write);
unsigned char mouse_read();
void mouse_install();
void mouse_xy();
void mouseps2RoutinesFor(console* c);
uint8 mouse_status();

typedef struct DrvGeom {
   uint8 heads;
   uint8 tracks;
   uint8 spt;     /* sectors per track */
};

/* prototypes */
void int1c();
void floppy_install();
void deinit(void);
void reset(void);
bool diskchange(void);
void motoron(void);
void motoroff(void);
void recalibrate(void);
bool seek(int track);
bool log_disk(DrvGeom *g);
bool read_block(int block,uint8 *blockbuff);
bool write_block(int block,uint8 *blockbuff);
bool format_track(uint8 track,DrvGeom *g);
void sendbyte(int byte);
int getbyte();
void floppy_handler(regs*t);
void int1c(void);
bool waitfdc(bool sensei);
bool fdc_rw(int block,uint8 *blockbuff,bool read);
void senduint8(int value);
int getuint8();

