
#include "system.h"


void *memcpy(void *dest, const void *src, size_t count)
{
    const char *sp = (const char *)src;
    char *dp = (char *)dest;
    for(; count != 0; count--) *dp++ = *sp++;
    return dest;
}

void *memset(void *dest, char val, size_t count)
{
    char *temp = (char *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}

unsigned short *memsetw(unsigned short *dest, unsigned short val, size_t count)
{
    unsigned short *temp = (unsigned short *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}

size_t strlen(const char *str)
{
    size_t retval;
    for(retval = 0; *str != '\0'; str++) retval++;
    return retval;
}


void itoa(int n, int base, char s[])
 {
     int i, sign;
 
     if ((sign = n) < 0)  /* record sign */
         n = -n;          /* make n positive */
     i = 0;
     do {       /* generate digits in reverse order */
         if(base<=10)s[i++] = n % base + '0';   /* get next digit */
         else{
              if((n % base)==0)s[i++]='0';
              else if((n % base)==1)s[i++]='1';
              else if((n % base)==2)s[i++]='2';
              else if((n % base)==3)s[i++]='3';
              else if((n % base)==4)s[i++]='4';
              else if((n % base)==5)s[i++]='5';
              else if((n % base)==6)s[i++]='6';
              else if((n % base)==7)s[i++]='7';
              else if((n % base)==8)s[i++]='8';
              else if((n % base)==9)s[i++]='9';
              else if((n % base)==10)s[i++]='A';
              else if((n % base)==11)s[i++]='B';
              else if((n % base)==12)s[i++]='C';
              else if((n % base)==13)s[i++]='D';
              else if((n % base)==14)s[i++]='E';
              else if((n % base)==15)s[i++]='F';
              }
     } while ((n /= base) > 0);     /* delete it */
     if (sign < 0)
         s[i++] = '-';
     s[i] = '\0';
     reverse(s);
 }
 

void reverse(char s[])
 {
     int i, j;
     char c;
 
     for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
         c = s[i];
         s[i] = s[j];
         s[j] = c;
     }
 }


