#include "system.h"

//Mouse.inc by SANiK
//License: Use as you wish, except to cause damage
unsigned char mouse_cycle=0;     //unsigned char
signed char mouse_byte[4];    //signed char
signed char mouse_x=0;         //signed char
signed char  mouse_y=0;         //signed char

int16 pointerX=0;
int16 pointerY=0;

struct{
       uint8 lp:1;
       uint8 mp:1;
       uint8 rp:1;
       uint8 mv:1;
       uint8 f0:3;
       }mouseevents;


//Mouse functions
void mouse_handler(struct regs *r) //struct regs *a_r (not used but just there)
{
 //Doesnt work on virtual machine.... a different kind of mouse is emulated     
  switch(mouse_cycle)
  {
    case 0:
      mouse_byte[0]=inportb(0x60);
      mouse_cycle++;
      break;
    case 1:
      mouse_byte[1]=inportb(0x60);
      mouse_cycle++;
      break;
    case 2:
      mouse_byte[2]=inportb(0x60);
      mouse_x=mouse_byte[1];
      mouse_y=mouse_byte[2];
      //mouse_cycle++;
      mouse_cycle=0; //3 pacchetti
      
      pointerX+=mouse_x;
      pointerY-=mouse_y;               //Asse invertito
      
      System.pointerXY();
      System.drawPointer();
    
    //System.puts("Mouse:\n");
    
 /*
    if(mouseevents.lp==0 && (mouse_byte[0] & 0x1)==1 && mouse_byte[1]==0 && mouse_byte[2]==0)System.puts("Left down\n");
    else if(mouseevents.lp==1 && (mouse_byte[0] & 0x1)!=1 && mouse_byte[1]==0 && mouse_byte[2]==0)System.puts("Left up\n");
    
    if(mouseevents.mp==0 && (mouse_byte[0] & 0x4)==4 && mouse_byte[1]==0 && mouse_byte[2]==0)System.puts("Middle down\n");
    else if(mouseevents.mp==1 && (mouse_byte[0] & 0x4)!=2 && mouse_byte[1]==0 && mouse_byte[2]==0)System.puts("Middle up\n");
    
    if(mouseevents.rp==0 && (mouse_byte[0] & 0x2)==2 && mouse_byte[1]==0 && mouse_byte[2]==0)System.puts("Right down\n");
    else if(mouseevents.rp==1 && (mouse_byte[0] & 0x2)!=2 && mouse_byte[1]==0 && mouse_byte[2]==0)System.puts("Right up\n");
    
    if(mouseevents.lp==1 && (mouse_byte[0] & 0x1)==1 && (mouse_byte[1]!=0 || mouse_byte[2]!=0))System.puts("Drag Left\n");
    if(mouseevents.mp==1 && (mouse_byte[0] & 0x4)==4 && (mouse_byte[1]!=0 || mouse_byte[2]!=0))System.puts("Drag Middle\n");
    if(mouseevents.rp==1 && (mouse_byte[0] & 0x2)==2 && (mouse_byte[1]!=0 || mouse_byte[2]!=0))System.puts("Drag Right\n");
    
 */
    
    if(mouseevents.lp==0 && (mouse_byte[0] & 0x1)==1 && mouse_byte[1]==0 && mouse_byte[2]==0)System.onLeftDown();
    else if(mouseevents.lp==1 && (mouse_byte[0] & 0x1)!=1 && mouse_byte[1]==0 && mouse_byte[2]==0)System.onLeftUp();
    
    if(mouseevents.mp==0 && (mouse_byte[0] & 0x4)==4 && mouse_byte[1]==0 && mouse_byte[2]==0)System.onMiddleDown();
    else if(mouseevents.mp==1 && (mouse_byte[0] & 0x4)!=2 && mouse_byte[1]==0 && mouse_byte[2]==0)System.onMiddleUp();
    
    if(mouseevents.rp==0 && (mouse_byte[0] & 0x2)==2 && mouse_byte[1]==0 && mouse_byte[2]==0)System.onRightDown();
    else if(mouseevents.rp==1 && (mouse_byte[0] & 0x2)!=2 && mouse_byte[1]==0 && mouse_byte[2]==0)System.onRightUp();
    
    if(mouseevents.lp==1 && (mouse_byte[0] & 0x1)==1 && (mouse_byte[1]!=0 || mouse_byte[2]!=0))System.onLeftDrag();
    if(mouseevents.mp==1 && (mouse_byte[0] & 0x4)==4 && (mouse_byte[1]!=0 || mouse_byte[2]!=0))System.onMiddleDrag();
    if(mouseevents.rp==1 && (mouse_byte[0] & 0x2)==2 && (mouse_byte[1]!=0 || mouse_byte[2]!=0))System.onRightDrag();
    
    if((mouse_byte[0] & 0x1)==1)mouseevents.lp=1;
    else mouseevents.lp=0;
    
    if((mouse_byte[0] & 0x4)==4)mouseevents.mp=1;
    else mouseevents.mp=0;
    
    if((mouse_byte[0] & 0x2)==2)mouseevents.rp=1;
    else mouseevents.rp=0;
    
    if(mouse_byte[1]!=0 || mouse_byte[2]!=0)mouseevents.mv=1;
    else mouseevents.mv=0;
    
    break;
        case 3:
      mouse_byte[3]=inportb(0x60);
      mouse_cycle=0;
      break;
}
}
inline void mouse_wait(unsigned char a_type) //unsigned char
{
  uint32 _time_out=100000; //unsigned int
  if(a_type==0)
  {
    while(_time_out--) //Data
    {
      if((inportb(0x64) & 1)==1)
      {
        return;
      }
    }
    return;
  }
  else
  {
    while(_time_out--) //Signal
    {
      if((inportb(0x64) & 2)==0)
      {
        return;
      }
    }
    return;
  }
}

inline void mouse_write(unsigned char a_write) //unsigned char
{
  //Wait to be able to send a command
  mouse_wait(1);
  //Tell the mouse we are sending a command
  outportb(0x64, 0xD4);
  //Wait for the final part
  mouse_wait(1);
  //Finally write
  outportb(0x60, a_write);
}

unsigned char mouse_read()
{
  //Get's response from mouse
  mouse_wait(0);
  return inportb(0x60);
}

void mouse_install()
{
  unsigned char _status;  //unsigned char

  //Enable the auxiliary mouse device
  mouse_wait(1);
  outportb(0x64, 0xA8);
 
  //Enable the interrupts
  mouse_wait(1);
  outportb(0x64, 0x20);
  mouse_wait(0);
  _status=(inportb(0x60) | 2);
  mouse_wait(1);
  outportb(0x64, 0x60);
  mouse_wait(1);
  outportb(0x60, _status);
 
  //Tell the mouse to use default settings
  mouse_write(0xF6);
  mouse_read();  //Acknowledge
 
  //Enable the mouse
  mouse_write(0xF4);
  mouse_read();  //Acknowledge

  

  //Setup the mouse handler
  irq_install_handler(12, mouse_handler);
}

void mouse_xy(){
          System.pointerX=pointerX;
          System.pointerY=pointerY;
          return;
          }
     
     
uint8 mouse_status(){
      mouse_write(0xEB);
      if(mouse_read()==0xfa){mouse_read();mouse_read();mouse_read();return 0;}  //Acknowledge
      else{mouse_read();mouse_read();mouse_read();return 1;}
      
      }
          
void mouseps2RoutinesFor(console* c){
     c->pointerXY=mouse_xy;
     return;
     }

