#ifndef _SYSTEM_H
#define _SYSTEM_H

#define _STI_ __asm__ __volatile__ ("sti");
#define _CLI_ __asm__ __volatile__ ("cli");
#define assert(ignore)((void) 0)


typedef int size_t;
typedef unsigned char uint8;
typedef unsigned short int uint16;
typedef unsigned int uint32;
typedef char int8;
typedef short int int16;
typedef int int32;


struct regs
{
    unsigned int gs, fs, es, ds;
    unsigned int edi, esi, ebp, esp, ebx, edx, ecx, eax;
    unsigned int int_no, err_code;
    unsigned int eip, cs, eflags, useresp, ss;    
}__attribute__((__packed__ ));


       
struct pointerPt{
       uint16 x;
       uint16 y;
}__attribute__((__packed__ ));

#include "libs.h"
#include "graphic.h"
#include "arch.h"
#include "hw.h"


#endif
