#include "system.h"

char* vga=(char*)0xb8000;
uint32 x_vga=0;
uint32 y_vga=0;

uint32 mx_vga=80;
uint32 my_vga=50;

depth vga_tdepth(1,1,1,0,1);        //Dept of text
depth vga_bdepth(1,1,1,0,1);        //Dept of background. The last bit can be flash or intensity


void vga_cls(){
     for(int i=0;i!=(my_vga*mx_vga)*2;i++){if(i%2!=0)vga[i]='r';else vga[i]=' ';}
     x_vga=0;
     y_vga=0;
     }

void vga_putc(char c){
     if(c=='\n' && y_vga+1<my_vga){y_vga++;x_vga=0;return;}
     else if(c=='\n' && y_vga+1>=my_vga){y_vga=0;x_vga=0;return;}
     
     else if(c=='\t'){vga_putc(' ');vga_putc(' ');vga_putc(' ');vga_putc(' ');return;}
     
     else if(c=='\f'){vga_cls();return;}

     else if(c=='\a'){spk_beep();return;}
     
     else{
     vga[(y_vga*mx_vga+x_vga)*2]=(char)c;
     vga[(y_vga*mx_vga+x_vga)*2+1]='r';
     }
     
      if(y_vga==my_vga-1 && x_vga==mx_vga-1){y_vga=0;x_vga=0;}
      else if(x_vga==mx_vga-1){y_vga++;x_vga=0;}
      else x_vga++;
     };
     
void vga_putc(char c, vgaColor p){
     vgaColor_union a;
     a.complex=p;
     
     if(c=='\n' && y_vga+1<my_vga){y_vga++;x_vga=0;return;}
     else if(c=='\n' && y_vga+1>=my_vga){y_vga=0;x_vga=0;return;}
     
     else if(c=='\t'){vga_putc(' ');vga_putc(' ');vga_putc(' ');vga_putc(' ');return;}
     
     else if(c=='\f'){vga_cls();return;}

     else if(c=='\a'){spk_beep();return;}
     
     else{
     vga[(y_vga*mx_vga+x_vga)*2]=(char)c;
     vga[(y_vga*mx_vga+x_vga)*2+1]=a.ch;
     }
     
      if(y_vga==my_vga-1 && x_vga==mx_vga-1){y_vga=0;x_vga=0;}
      else if(x_vga==mx_vga-1){y_vga++;x_vga=0;}
      else x_vga++;
     };




void vga_puts(char* c){
     int i=0;
     for(;c[i]!=0;c++)vga_putc(c[i]);
     }
     
vgaColor fromColor(color t, color b){
         vgaColor temp;
         temp.tr=t.red>>7;
         temp.tg=t.green>>7;
         temp.tb=t.blue>>7;
         if((t.red-128>=64) | (t.green-128>=64) | (t.blue-128>=64))temp.ti=1;
         else temp.ti=0;
                                           
         temp.br=b.red>>7;
         temp.bg=b.green>>7;
         temp.bb=b.blue>>7;
         if((b.red-128>=64) | (b.green-128>=64) | (b.blue-128>=64))temp.bi=1;
         else temp.bi=0;
         return temp;
         }     
     
     
void vga_print(char* c, uint16 x, uint16 y, color t, color b){
     uint16 tx,ty;
     tx=x_vga;
     ty=y_vga;
     
     x_vga=x;
     y_vga=y;
     int i=0;
     for(;c[i]!=0;c++)vga_putc(c[i], fromColor(t, b));
     x_vga=tx;
     y_vga=ty;
     }

void vga_printi(int32 n, int32 base, uint16 x, uint16 y, color t, color b){
     char current[32];
     itoa(n,base,current);
     vga_print(current, x,y,t,b);
     //if(base==16)vga_putc('h', fromColor(t, b));
     //else if(base==8)vga_putc('o', fromColor(t, b));    
     //else if(base==2)vga_putc('b', fromColor(t, b));
     }

void vga_puti(int32 n, int32 b){
     char current[32];
     itoa(n,b,current);
     vga_puts(current);
     //if(b==16)vga_putc('h');
     //else if(b==8)vga_putc('o');    
     //else if(b==2)vga_putc('b');    
     return;
     }
     
void vga_drawPointer(){
     static int16* vga2=(int16*)0xb8000;
     static int16 oldx=-1;
     static int16 oldy=-1;
     static int16 content=0;
     
     if(oldx!=-1){     
     vga2[(oldy*80+oldx)]=content;      //Not the first time
     }
     
      if(System.pointerX<0)System.pointerX=0;
      if(System.pointerY<0)System.pointerY=0;
      
      if(System.pointerX>79)System.pointerX=79;
      if(System.pointerY>49)System.pointerY=49;
     
     content=vga2[(System.pointerY*80+System.pointerX)];
     oldx=System.pointerX;
     oldy=System.pointerY;
     
     
      color a(255,255,255),b(129,129,129);
     
      
      System.print("X", System.pointerX,System.pointerY,a,b);     //Use a more compact function
}


void vgaRoutinesFor(console* c){
     c->putc=vga_putc;
     c->puts=vga_puts;
     c->print=vga_print;
     c->cls=vga_cls;
     c->puti=vga_puti;
     c->printi=vga_printi;
     c->drawPointer=vga_drawPointer;
     return;
     }
